package rpc

import (
	"git.loafle.net/commons_go/rpc/protocol"
	cuc "git.loafle.net/commons_go/util/context"
)

type ServletHandler interface {
	ServletContext(parent cuc.Context) ServletContext

	Init(servletCTX ServletContext) error

	GetRequest(servletCTX ServletContext, codec protocol.ServerCodec, reader interface{}) (protocol.ServerRequestCodec, error)
	Invoke(servletCTX ServletContext, requestCodec protocol.RegistryCodec) (result interface{}, err error)
	SendResponse(servletCTX ServletContext, requestCodec protocol.ServerRequestCodec, writer interface{}, result interface{}, err error) error
	SendNotification(servletCTX ServletContext, codec protocol.ServerCodec, writer interface{}, method string, args ...interface{}) error

	Destroy(servletCTX ServletContext)

	RegisterCodec(contentType string, codec protocol.ServerCodec)

	getCodec(contentType string) (protocol.ServerCodec, error)

	GetPendingMessages() int
	Validate()
}
